#define assume(e) __CPROVER_assume(e)
#define predicate(e) __CPROVER_predicate(e)
#define atomic(e,f) __CPROVER_atomic_begin(),e,f,__CPROVER_atomic_end()
#define acquire(m) atomic(assume(!m),m = !m)
#define release(m) atomic(assume(m),m = !m)

volatile unsigned int count = 0; //shared
_Bool MTX = 0; //shared mutex
_Thread_local _Bool COND = 0; //condition variables become local flag indicating whether the thread was signaled

#define cnd_wait(c,m){ \
  release(m); \
  assume(c); \
  c = 0; \
  acquire(m); }

#ifdef NO_CPROVER_passive
#define cnd_broadcast(c) (c = 1) //BP must be post-processed manually by changing "b*_COND := 1" to "b*_COND$ := 1"
#else
#define cnd_broadcast(c) (__CPROVER_passive(c = 1)) //set passive waiting flags (requires a new keywork!)
#endif

void Barrier2() {  
  acquire(MTX);
  count++;
  if (count == 3) {
    cnd_broadcast(COND); //pthread_cond_broadcast(&cond);
    count = 0; }
  else
    cnd_wait(COND,MTX); //pthread_cond_wait(&cond, &m);
  release(MTX); }
  
void thr(){
  predicate(count==0);
  predicate(count==1);
  predicate(count==2);
  predicate(count==3);
  predicate(MTX);
  predicate(COND);

  Barrier2();
  assert(0); } //should not fail for <3 threads

int main(){while(1) __CPROVER_ASYNC_01: thr();}
